#include "llvm/CodeGen/MachineInstrBuilder.h"
//===- TableGen'erated file -------------------------------------*- C++ -*-===//
//
// Instruction Selector for the X86 target
//
// Automatically generated file, do not edit!
//
//===----------------------------------------------------------------------===//

namespace llvm {


enum { // Slot numbers...
  LastBuiltinSlot = ISD::NumBuiltinSlots-1, // Start numbering here
  Void_void_Slot,
  NumSlots
};

// Reduction value typedefs...
typedef ReducedValue<unsigned, Void_void_Slot> ReducedValue_Void_void;


enum { // Patterns...
  NotComputed = 0,
  NoMatchPattern, 
  // Void_void patterns...
  ChainExpander_Pattern,
  BlockChainExpander_Pattern,
};

namespace {
  class X86ISel {
    SelectionDAG &DAG;
  public:
    X86ISel(SelectionDAG &D) : DAG(D) {}
    void generateCode();
  private:
    unsigned makeAnotherReg(const TargetRegisterClass *RC) {
      return DAG.getMachineFunction().getSSARegMap()->createVirtualRegister(RC);
    }

    // DAG matching methods for classes... all of these methods return the cost
    // of producing a value of the specified class and type, which also gets
    // added to the DAG node.
    unsigned Match_Void_void(SelectionDAGNode *N);

    // DAG matching methods for DAG nodes...
    unsigned Match_Void_void_ChainNode(SelectionDAGNode *N);
    unsigned Match_Void_void_BlockChainNode(SelectionDAGNode *N);

    // DAG reduction methods...
    ReducedValue_Void_void *Reduce_Void_void(SelectionDAGNode *N,
                                             MachineBasicBlock *MBB);
  };
}

void X86ISel::generateCode() {
  SelectionDAGNode *Root = DAG.getRoot();
  assert(Root->getValueType() == MVT::isVoid && "Root of DAG produces value??");

  std::cerr << "\n";
  unsigned Cost = Match_Void_void(Root);
  if (Cost >= ~0U >> 1) {
    std::cerr << "Match failed!\n";
    Root->dump();
    abort();
  }

  std::cerr << "Total DAG Cost: " << Cost << "\n\n";

  Reduce_Void_void(Root, 0);
}

//===----------------------------------------------------------------------===//
//  Matching methods...
//

unsigned X86ISel::Match_Void_void(SelectionDAGNode *N) {
  assert(N->getValueType() == MVT::isVoid);
  // If we already have a cost available for Void_void use it!
  if (N->getPatternFor(Void_void_Slot))
    return N->getCostFor(Void_void_Slot);

  unsigned Cost;
  switch (N->getNodeType()) {
  default: Cost = ~0U >> 1;   // Match failed
           N->setPatternCostFor(Void_void_Slot, NoMatchPattern, Cost, NumSlots);
           break;
  case ISD::ChainNode:	Cost = Match_Void_void_ChainNode(N); break;
  case ISD::BlockChainNode:	Cost = Match_Void_void_BlockChainNode(N); break;
  }
  return Cost;
}

unsigned X86ISel::Match_Void_void_ChainNode(SelectionDAGNode *N) {
  unsigned Pattern = NoMatchPattern;
  unsigned MinCost = ~0U >> 1;
  SelectionDAGNode *N_Op0 = N->getUse(0);
  SelectionDAGNode *N_Op1 = N->getUse(1);

  // Operand matching costs...
  unsigned N_Op0_Void_Cost = Match_Void_void(N_Op0);
  unsigned N_Op1_Void_Cost = Match_Void_void(N_Op1);

  unsigned N_CostMin = ~0U >> 1;
  unsigned N_PatternMin = NoMatchPattern;
  {// Expander pattern    ChainExpander:	(void:chain void:Void, void:Void)
    unsigned PatCost = 1 + N_Op0_Void_Cost + N_Op1_Void_Cost;
    if (PatCost < MinCost) { MinCost = PatCost; Pattern = ChainExpander_Pattern; }
  }

  N->setPatternCostFor(Void_void_Slot, Pattern, MinCost, NumSlots);
  return MinCost;
}
unsigned X86ISel::Match_Void_void_BlockChainNode(SelectionDAGNode *N) {
  unsigned Pattern = NoMatchPattern;
  unsigned MinCost = ~0U >> 1;
  SelectionDAGNode *N_Op0 = N->getUse(0);
  SelectionDAGNode *N_Op1 = N->getUse(1);

  // Operand matching costs...
  unsigned N_Op0_Void_Cost = Match_Void_void(N_Op0);
  unsigned N_Op1_Void_Cost = Match_Void_void(N_Op1);

  unsigned N_CostMin = ~0U >> 1;
  unsigned N_PatternMin = NoMatchPattern;
  {// Expander pattern    BlockChainExpander:	(void:blockchain void:Void, void:Void)
    unsigned PatCost = 1 + N_Op0_Void_Cost + N_Op1_Void_Cost;
    if (PatCost < MinCost) { MinCost = PatCost; Pattern = BlockChainExpander_Pattern; }
  }

  N->setPatternCostFor(Void_void_Slot, Pattern, MinCost, NumSlots);
  return MinCost;
}


//===----------------------------------------------------------------------===//
// Reducer methods...
//
ReducedValue_Void_void *X86ISel::Reduce_Void_void(SelectionDAGNode *N, MachineBasicBlock *MBB) {
  ReducedValue_Void_void *Val = N->hasValue<ReducedValue_Void_void>(Void_void_Slot);
  if (Val) return Val;
  if (N->getBB()) MBB = N->getBB();

  switch (N->getPatternFor(Void_void_Slot)) {
  case ChainExpander_Pattern: {
    // Expander pattern    ChainExpander:	(void:chain void:Void, void:Void)
    SelectionDAGNode *N_Op0 = N->getUse(0);
    ReducedValue_Void_void *N_Op0Val = Reduce_Void_void(N_Op0, MBB);
    SelectionDAGNode *N_Op1 = N->getUse(1);
    ReducedValue_Void_void *N_Op1Val = Reduce_Void_void(N_Op1, MBB);
    Val = new ReducedValue_Void_void(0);
    break;
  }
  case BlockChainExpander_Pattern: {
    // Expander pattern    BlockChainExpander:	(void:blockchain void:Void, void:Void)
    SelectionDAGNode *N_Op0 = N->getUse(0);
    ReducedValue_Void_void *N_Op0Val = Reduce_Void_void(N_Op0, MBB);
    SelectionDAGNode *N_Op1 = N->getUse(1);
    ReducedValue_Void_void *N_Op1Val = Reduce_Void_void(N_Op1, MBB);
    Val = new ReducedValue_Void_void(0);
    break;
  }
  default: assert(0 && "Unknown Void_void pattern!");
  }

  N->addValue(Val);  // Do not ever recalculate this
  return Val;
}

} // End llvm namespace 
