//===- TableGen'erated file -------------------------------------*- C++ -*-===//
//
// Register Information Source Fragment
//
// Automatically generated file, do not edit!
//
//===----------------------------------------------------------------------===//

namespace llvm {

namespace {     // Register classes...
  // R16 Register Class...
  const unsigned R16[] = {
    X86::AX, X86::CX, X86::DX, X86::SI, X86::DI, X86::BX, X86::BP, X86::SP, 
  };

  struct R16Class : public TargetRegisterClass {
    R16Class() : TargetRegisterClass(2, 2, R16, R16 + 8) {}

    iterator allocation_order_end(MachineFunction &MF) const {
      if (hasFP(MF))     // Does the function dedicate EBP to being a frame ptr?
        return end()-2;  // If so, don't allocate SP or BP
      else
        return end()-1;  // If not, just don't allocate SP
    }
    } R16Instance;

  // R32 Register Class...
  const unsigned R32[] = {
    X86::EAX, X86::ECX, X86::EDX, X86::ESI, X86::EDI, X86::EBX, X86::EBP, X86::ESP, 
  };

  struct R32Class : public TargetRegisterClass {
    R32Class() : TargetRegisterClass(4, 4, R32, R32 + 8) {}

    iterator allocation_order_end(MachineFunction &MF) const {
      if (hasFP(MF))     // Does the function dedicate EBP to being a frame ptr?
        return end()-2;  // If so, don't allocate ESP or EBP
      else
        return end()-1;  // If not, just don't allocate ESP
    }
    } R32Instance;

  // R8 Register Class...
  const unsigned R8[] = {
    X86::AL, X86::AH, X86::CL, X86::CH, X86::DL, X86::DH, X86::BL, X86::BH, 
  };

  struct R8Class : public TargetRegisterClass {
    R8Class() : TargetRegisterClass(1, 1, R8, R8 + 8) {}
  } R8Instance;

  // RFP Register Class...
  const unsigned RFP[] = {
    X86::FP0, X86::FP1, X86::FP2, X86::FP3, X86::FP4, X86::FP5, X86::FP6, 
  };

  struct RFPClass : public TargetRegisterClass {
    RFPClass() : TargetRegisterClass(10, 4, RFP, RFP + 7) {}
  } RFPInstance;

  // RST Register Class...
  const unsigned RST[] = {
    X86::ST0, X86::ST1, X86::ST2, X86::ST3, X86::ST4, X86::ST5, X86::ST6, X86::ST7, 
  };

  struct RSTClass : public TargetRegisterClass {
    RSTClass() : TargetRegisterClass(10, 4, RST, RST + 8) {}
  } RSTInstance;

  const TargetRegisterClass* const RegisterClasses[] = {
    &R16Instance,
    &R32Instance,
    &R8Instance,
    &RFPInstance,
    &RSTInstance,
  };


  // Register Alias Sets...
  const unsigned Empty_AliasSet[] = { 0 };
  const unsigned EAX_AliasSet[] = { X86::AX, X86::AL, X86::AH, 0 };
  const unsigned ECX_AliasSet[] = { X86::CX, X86::CL, X86::CH, 0 };
  const unsigned EDX_AliasSet[] = { X86::DX, X86::DL, X86::DH, 0 };
  const unsigned EBX_AliasSet[] = { X86::BX, X86::BL, X86::BH, 0 };
  const unsigned ESP_AliasSet[] = { X86::SP, 0 };
  const unsigned EBP_AliasSet[] = { X86::BP, 0 };
  const unsigned ESI_AliasSet[] = { X86::SI, 0 };
  const unsigned EDI_AliasSet[] = { X86::DI, 0 };
  const unsigned AX_AliasSet[] = { X86::EAX, X86::AL, X86::AH, 0 };
  const unsigned CX_AliasSet[] = { X86::ECX, X86::CL, X86::CH, 0 };
  const unsigned DX_AliasSet[] = { X86::EDX, X86::DL, X86::DH, 0 };
  const unsigned BX_AliasSet[] = { X86::EBX, X86::BL, X86::BH, 0 };
  const unsigned SP_AliasSet[] = { X86::ESP, 0 };
  const unsigned BP_AliasSet[] = { X86::EBP, 0 };
  const unsigned SI_AliasSet[] = { X86::ESI, 0 };
  const unsigned DI_AliasSet[] = { X86::EDI, 0 };
  const unsigned AL_AliasSet[] = { X86::EAX, X86::AX, 0 };
  const unsigned CL_AliasSet[] = { X86::ECX, X86::CX, 0 };
  const unsigned DL_AliasSet[] = { X86::EDX, X86::DX, 0 };
  const unsigned BL_AliasSet[] = { X86::EBX, X86::BX, 0 };
  const unsigned AH_AliasSet[] = { X86::EAX, X86::AX, 0 };
  const unsigned CH_AliasSet[] = { X86::ECX, X86::CX, 0 };
  const unsigned DH_AliasSet[] = { X86::EDX, X86::DX, 0 };
  const unsigned BH_AliasSet[] = { X86::EBX, X86::BX, 0 };

  const MRegisterDesc RegisterDescriptors[] = { // Descriptors
    { "NOREG",	0,		0,	0 },
    { "AH",	AH_AliasSet,	0, 0 },
    { "AL",	AL_AliasSet,	0, 0 },
    { "AX",	AX_AliasSet,	0, 0 },
    { "BH",	BH_AliasSet,	0, 0 },
    { "BL",	BL_AliasSet,	0, 0 },
    { "BP",	BP_AliasSet,	0, 0 },
    { "BX",	BX_AliasSet,	0, 0 },
    { "CH",	CH_AliasSet,	0, 0 },
    { "CL",	CL_AliasSet,	0, 0 },
    { "CX",	CX_AliasSet,	0, 0 },
    { "DH",	DH_AliasSet,	0, 0 },
    { "DI",	DI_AliasSet,	0, 0 },
    { "DL",	DL_AliasSet,	0, 0 },
    { "DX",	DX_AliasSet,	0, 0 },
    { "EAX",	EAX_AliasSet,	0, 0 },
    { "EBP",	EBP_AliasSet,	0, 0 },
    { "EBX",	EBX_AliasSet,	0, 0 },
    { "ECX",	ECX_AliasSet,	0, 0 },
    { "EDI",	EDI_AliasSet,	0, 0 },
    { "EDX",	EDX_AliasSet,	0, 0 },
    { "ESI",	ESI_AliasSet,	0, 0 },
    { "ESP",	ESP_AliasSet,	0, 0 },
    { "FP0",	Empty_AliasSet,	0, 0 },
    { "FP1",	Empty_AliasSet,	0, 0 },
    { "FP2",	Empty_AliasSet,	0, 0 },
    { "FP3",	Empty_AliasSet,	0, 0 },
    { "FP4",	Empty_AliasSet,	0, 0 },
    { "FP5",	Empty_AliasSet,	0, 0 },
    { "FP6",	Empty_AliasSet,	0, 0 },
    { "SI",	SI_AliasSet,	0, 0 },
    { "SP",	SP_AliasSet,	0, 0 },
    { "ST(0)",	Empty_AliasSet,	0, 0 },
    { "ST(1)",	Empty_AliasSet,	0, 0 },
    { "ST(2)",	Empty_AliasSet,	0, 0 },
    { "ST(3)",	Empty_AliasSet,	0, 0 },
    { "ST(4)",	Empty_AliasSet,	0, 0 },
    { "ST(5)",	Empty_AliasSet,	0, 0 },
    { "ST(6)",	Empty_AliasSet,	0, 0 },
    { "ST(7)",	Empty_AliasSet,	0, 0 },
  };
}

namespace X86 { // Register classes
  TargetRegisterClass *R16RegisterClass = &R16Instance;
  TargetRegisterClass *R32RegisterClass = &R32Instance;
  TargetRegisterClass *R8RegisterClass = &R8Instance;
  TargetRegisterClass *RFPRegisterClass = &RFPInstance;
  TargetRegisterClass *RSTRegisterClass = &RSTInstance;
} // end of namespace X86

X86GenRegisterInfo::X86GenRegisterInfo(int CallFrameSetupOpcode, int CallFrameDestroyOpcode)
  : MRegisterInfo(RegisterDescriptors, 40, RegisterClasses, RegisterClasses+5,
                  CallFrameSetupOpcode, CallFrameDestroyOpcode) {}

const unsigned* X86GenRegisterInfo::getCalleeSaveRegs() const {
  static const unsigned CalleeSaveRegs[] = {
    X86::ESI, X86::EDI, X86::EBX, X86::EBP,  0
  };
  return CalleeSaveRegs;
}

} // End llvm namespace 
